$(document).ready(function() {
	let $listeLovers= $("#listLovers");
	let $listeProfilesDelete = $("#listProfilesDelete");
	let $listeProfilesSelect = $("#listProfilesSelect");
	let $listeProfilesSelect2 = $("#listProfilesSelect2");
	let $listeMatches= $("#listMatches");
	let $listeMyProfile= $("#myProfile");
	let $selectLovers = $("#selectLovers");
	let $selectLovers2 = $("#selectLovers2");

    $.get("http://localhost:8080/api/profiles",function(resp){
		resp.forEach( p => {
			appendToListProfileDelete(p);
			appendToListProfileSelect(p);
			appendToListProfileSelect2(p);
		});
    });

	$.get("http://localhost:8080/api/lovers",function(resp){
		resp.forEach( l => {
			appendToListLover(l);
			appendToSelects(l);
		});
	});
	
    $listeProfilesDelete.on("click", "li button", function() {
		let elemid = $(this).parent().attr('id');
		$.ajax({
			type: "DELETE",
			url: "http://localhost:8080/api/profiles/" + elemid.replace('profile-',''),
			dataType: "json",
			success: function(data){
				$("#"+elemid).remove();
			}
		});
	});

	$listeProfilesSelect.on("click", "li button", function() {
		let idLover = $(this).attr('id');

		$.get("http://localhost:8080/api/profiles/"+idLover+"/loversmatch",function(resp){
				resp.forEach( p => appendToListMatches(p));
			});
	});
	
	$listeProfilesSelect2.on("click", "li button", function() {
		let idProfile = $(this).parent().attr('id');

		$.ajax({
			type: "GET",
			url: "http://localhost:8080/api/profiles/"+idProfile.replace('profile-',''),
			dataType: "json",
			success: function(data){
				appendToListMyProfile(data);
			},
			error: function (xhr, ajaxOptions, thrownError) {
				console.log(xhr);
				alert("Impossible de trouver le profile");
			}
		});
	});

	$listeLovers.on("click", "li button", function() {
		let elemid = $(this).parent().attr('id');
		let idLover = elemid.replace('lover-','');

		$.ajax({
			type: "DELETE",
			url: "http://localhost:8080/api/lovers/"+idLover,
			dataType: "json",
			success: function(data){
				$("#"+elemid).remove();
				$(`#selectLovers option[value="${idLover}"]`).remove();
			},
			error: function (xhr, ajaxOptions, thrownError) {
				console.log(xhr);
				alert("Impossible de supprimer le lover, il est peut-être encore utilisé");
			}
		});
	});

    $('#addbtnProfile').click(function(){
		let firstname = $('#firstname-input').val();
		let age = $('#age-input').val();
		let gender = $('#gender-input').val();
		let pet = $('#pet-input').val();
		let contact= $('#contact-input').val();
		let idLover = $selectLovers.val();
		
		$.ajax({
		    type: "POST",
		    url: "http://localhost:8080/api/profiles",
		    data: JSON.stringify({ "firstname": firstname, "age" : age, "gender": gender, "pet": pet, "contact": contact}),
		    contentType: "application/json; charset=utf-8",
		    dataType: "json",
			success: function(data){
				addLoverToProfile(data.id, idLover);
			}
		});	
		
		$('#firstname-input').val('');
		$('#age-input').val('');
		$('#gender-input').val('');
		$('#pet-input').val('');
		$('#contact-input').val('');
		return false;
	});

	$('#addbtnLover').click(function(){
		let lover = {
			partnerGender: $('#partner-input').val(),
			partnerPet: $('#partner-pet-input').val()
		};
		$.ajax({
			type: "POST",
			url: "http://localhost:8080/api/lovers",
			data: JSON.stringify(lover),
			contentType: "application/json; charset=utf-8",
			dataType: "json",
			success: function(data){
				appendToListLover(data);
				appendToSelects(data);
			}
		});

		$('#partner-input').val('');
		$('#partner-pet-input').val('');
		return false;
	});

	/* Ajoute un élément li dans la liste de lovers*/
	function appendToListLover(lover) {
		$listeLovers.append(`<li id="lover-${lover.id}" class="list-group-item">${lover.partnerGender} - who likes ${lover.partnerPet} <button class="btn btn-danger btn-xs" data-title="Delete" data-toggle="modal" data-target="#delete" >X</button></li>`);
	}

	/* Ajoute un élément li dans le select des lovers*/
	function appendToSelects(lover) {
		$selectLovers.append(`<option value="${lover.id}">${lover.partnerGender} - who likes ${lover.partnerPet}</option>`);
		$selectLovers2.append(`<option value="${lover.id}">${lover.partnerGender} - who likes ${lover.partnerPet}</option>`);
	} 
	
	/* Ajoute un élément li pour supprimer dans la liste de profiles*/
	function appendToListProfileDelete(profile) {
	    liToAppend1 = `<li id="profile-${profile.id}" class="list-group-item">You are: ${profile.firstname} - age: ${profile.age}`;
		profile.lovers.forEach( lover => liToAppend1+= ` - interested in: ${lover.partnerGender} - who likes ${lover.partnerPet}`);
		liToAppend1+= ` <button class="btn btn-danger btn-xs" data-title="Delete" data-toggle="modal" data-target="#delete" >X</button></li>`;
		$listeProfilesDelete.append(liToAppend1);
	}
	/* Ajoute un élément li pour selectionner dans la liste de profiles*/
	function appendToListProfileSelect(profile) {
	    liToAppend2 = `<li id="${profile.id}" class="list-group-item">You are: ${profile.firstname} - age: ${profile.age}`;
		profile.lovers.forEach( lover => liToAppend2+= ` - interested in: ${lover.partnerGender} - who likes ${lover.partnerPet} <button id="${lover.id}" class="btn btn-success btn-xs"  data-title="Select" data-toggle="modal" data-target="#select" >;)</button>`);
		liToAppend2+= `</li>`;
		$listeProfilesSelect.append(liToAppend2);
	}

	/* Ajoute un élément li pour selectionner dans la liste de profiles
	function appendToListProfileSelect2(profile) {
	    liToAppend3 = `<li id="profile-${profile.id}" class="list-group-item">You are: ${profile.firstname} - age: ${profile.age}`;
		profile.lovers.forEach( lover => liToAppend3+= ` - interested in: ${lover.partnerGender} - who likes ${lover.partnerPet} <button id="${lover.id}" class="btn btn-success btn-xs"  data-title="Select" data-toggle="modal" data-target="#select" >o</button>`);
		liToAppend3+= `</li>`;
		$listeProfilesSelect2.append(liToAppend3);
	}*/

	/*Ajoute un élément option pour selectionner dans la liste de profiles*/
	function appendToListProfileSelect2(profile) {
		optionToAppend = `<option value="${profile.id}">Name: ${profile.firstname} - age: ${profile.age} - gender: ${profile.gender} - who likes: ${profile.pet} - contact info: ${profile.contact}`;
		profile.lovers.forEach( lover => optionToAppend+= ` - interested in: ${lover.partnerGender} - who likes ${lover.partnerPet}`);
		optionToAppend+= `</option>`;
		$listeProfilesSelect2.append(optionToAppend);
	}

	/* Ajoute un élément li dans la liste de matches*/
	function appendToListMatches(profile) {
	    liToAppend = `<li id="profile-${profile.id}" class="list-group-item">Match name: ${profile.firstname} - age: ${profile.age} - gender: ${profile.gender} - who likes: ${profile.pet} - contact info: ${profile.contact}</li>`;
		$listeMatches.append(liToAppend);
	}

	/* Ajoute un élément li dans la liste de matches
	function appendToListMyProfile(profile) {
	    liToAppend = `<li id="profile-${profile.id}" class="list-group-item">name: ${profile.firstname} - age: ${profile.age} - gender: ${profile.gender} - who likes: ${profile.pet} - contact info: ${profile.contact}`;
		profile.lovers.forEach( lover => liToAppend+= ` - interested in: ${lover.partnerGender} - who likes ${lover.partnerPet}`);
		liToAppend+= `</li>`;
		$listeMyProfile.append(liToAppend);
	}*/

	/* Ajout un lover à une profile existante*/
	function addLoverToProfile(idProfile, idLover) {
	    $.ajax({
    			type: "POST",
    			url: "http://localhost:8080/api/profiles/"+idProfile+"/lovers",
    			data: JSON.stringify({"idLover" : idLover}),
    			contentType: "application/json; charset=utf-8",
    			dataType: "json",
    			success: function(data){
    				appendToListProfileSelect(data);
					appendToListProfileSelect2(data);
					appendToListProfileDelete(data);
    			}
    	});
	};
});